﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            

            var dataArray = [
                   { title: "A", text: "AAAA" },
                   { title: "A", text: "AAAA" },
                   { title: "B", text: "BBBB" },
                   { title: "B", text: "BBBB" },
                   { title: "B", text: "BBBB" },
                   { title: "C", text: "CCCC" },
                   { title: "C", text: "CCCC" },
                   { title: "C", text: "CCCC" },
                   { title: "C", text: "CCCC" },
                   { title: "D", text: "DDDD" },
                   { title: "D", text: "DDDD" },
            ];

            var dataList = new WinJS.Binding.List(dataArray);

            var sortedList = dataList.createSorted(function (x, y) { return x.title < y.title; });
            var filteredList = dataList.createFiltered(function (x) { return x.title != "A"; });
            var groupedList = dataList.createGrouped(function (x) { return x.title; }, titleGroupData.bind(dataList));

            var publicMembers =
            {
                sortedList: sortedList,
                filteredList: filteredList,
                groupedList:groupedList
            };

            WinJS.Namespace.define("DataExample", publicMembers);

            args.setPromise(WinJS.UI.processAll());
        }
    };



    function titleGroupData(j) {
        
        var titleArray = this.filter(function (v) { return (v.title == j.title); })

        return {
            title: j.title,
            count: titleArray.length
        }
    }

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    app.start();
})();
