﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";
    var client = new WindowsAzure.MobileServiceClient(
        "https://examrefdemo.azure-mobile.net/",
        "gtUJXAviPIMyFOdhRypReTkvmpAetc41"
    );

    // Request a push notification channel.
    Windows.Networking.PushNotifications
        .PushNotificationChannelManager
        .createPushNotificationChannelForApplicationAsync()
        .then(function (channel) {
            // Register for notifications using the new channel
            client.push.registerNative(channel.uri);

            
        }, function (error) {
            var message = "Registration failed: " + error.message;
            var dialog = new Windows.UI.Popups.MessageDialog(message);
            dialog.showAsync();
        });

    

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            var launchString = args.detail.arguments;
            if (launchString)
            {
                var toastArgs = JSON.parse(launchString);
            }

            args.setPromise(WinJS.UI.processAll());

            document.getElementById("showToast").addEventListener("click", showToast);
        }
    };

    function showToast() {
        var item = { text: "Awesome item" };
        client.getTable("TodoItem").insert(item);
        
    }

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };



    app.start();
})();
